<?php

namespace App\DataTables;

use App\Models\MetodoPagamento;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class  MetodoPagamentoDataTableEditor extends DataTablesEditor
{
  protected $model = MetodoPagamento::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'nome.required' => 'Il nome è richiesto',
    'tipo.required' => 'Il tipo è richiesto',
    'is_attivo.required' => 'Indicare una delle due opzioni',
    'is_pubblico.required' => 'Indicare una delle due opzioni',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'nome'  => 'required',
      'tipo' => 'required|in:'.MetodoPagamento::getTipiPagamento()->pluck('value')->implode(','),
      // 'is_attivo' => 'boolean',
      // 'is_pubblico' => 'boolean',
      'key' => 'nullable',
      'secret' => 'nullable',
      'path_img' => 'nullable',
      'info' => 'nullable',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'nome'  => 'required',
      'tipo' => 'required|in:'.MetodoPagamento::getTipiPagamento()->pluck('value')->implode(','),
      'attivita_id' => 'required|exists:attivita,id',
      // 'is_attivo' => 'boolean',
      // 'is_pubblico' => 'boolean',
      'key' => 'nullable',
      'secret' => 'nullable',
      'path_img' => 'nullable',
      'info' => 'nullable',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attivo'] = isset($data['is_attivo']) ? true : false;
    $data['is_pubblico'] = isset($data['is_pubblico']) ? true : false;
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attivo'] = isset($data['is_attivo']) ? true : false;
    $data['is_pubblico'] = isset($data['is_pubblico']) ? true : false;
    return $data;
  }

  public function messages(): array
  {
    return $this->messages;
  }

}
